//+------------------------------------------------------------------+
//|                  MTF PriceActionChanel.mq4       PAC          ik |
//|                   PriceActionChanel      Envelopes               |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net    www.forex-tsd.com"
//---- indicator settings
#property indicator_chart_window
#property  indicator_buffers 2
#property  indicator_color1  DarkGoldenrod
#property  indicator_color2  DarkGoldenrod
#property indicator_width1 2
#property indicator_width2 2
//---- indicator parameters
extern int TimeFrame=0;
extern int MA_Period=5;
extern int MA_Shift=0;
extern int MA_Method=2;
extern int Applied_Price=0;
extern double Deviation=0.0;
extern int ______;
extern int SMA_0_EMA1_SMMA2_LWMA3;
extern int priceC0_O1_H2_L3; 
extern int Md4_Tp_5_WC6; 


/*************************************************************************
---------------------------------------
PRICE_CLOSE    0 Close price. 
PRICE_OPEN     1 Open price. 
PRICE_HIGH     2 High price. 
PRICE_LOW      3 Low price. 
PRICE_MEDIAN   4 Median price, (high+low)/2. 
PRICE_TYPICAL  5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 
You must use the numeric value of the Applied Price that you want to use
when you set the 'applied_price' value with the indicator inputs.
---------------------------------------
MODE_SMA    0 Simple moving average, 
MODE_EMA    1 Exponential moving average, 
MODE_SMMA   2 Smoothed moving average, 
MODE_LWMA   3 Linear weighted moving average. 
You must use the numeric value of the MA Method that you want to use
when you set the 'ma_method' value with the indicator inputs.

**************************************************************************/

//---- indicator buffers


double ExtMapBuffer1[];
double ExtMapBuffer2[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   int    draw_begin;
   string short_name;
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexShift(0,MA_Shift*TimeFrame/Period());
   SetIndexShift(1,MA_Shift*TimeFrame/Period());
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   if(MA_Period<2) MA_Period=14;
   draw_begin=MA_Period-1;
//---- indicator short name
   IndicatorShortName("PAC("+MA_Period+")");
   SetIndexLabel(0,"Env("+MA_Period+")Upper;TF"+TimeFrame+"s"+MA_Shift+"");
   SetIndexLabel(1,"Env("+MA_Period+")Lower;TF"+TimeFrame+"s"+MA_Shift+"");
   SetIndexDrawBegin(0,draw_begin);
   SetIndexDrawBegin(1,draw_begin);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   if(Deviation<0) Deviation=0;
   if(Deviation>100.0) Deviation=100.0;
//---- initialization done
   return(0);
  }
//    SetIndexLabel(0,"MTF_ADXBarsSmd("+ADXPeriod+")TF"+TimeFrame+"s"+Shift+"");

//---- 
 
 int start() 

  {
   datetime TimeArray[];
   int    i,shift,limit,y=0,counted_bars=IndicatorCounted();
     
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars+TimeFrame/Period();
   for(i=0,y=0;i<limit;i++) {
     if (Time[i]<TimeArray[y]) {y++;}   
     ExtMapBuffer1[i]=iCustom(NULL,TimeFrame,"PriceActionChanel",MA_Period,MA_Method,MA_Shift,Applied_Price, 0,y); 
     ExtMapBuffer2[i]=iCustom(NULL,TimeFrame,"PriceActionChanel",MA_Period,MA_Method,MA_Shift,Applied_Price, 1,y);
   }
   return(0);
  }

 
 